<?php
/******************************************************************************
  Administration - Configuration générale
******************************************************************************/

// Initialisation des variables
empty($_POST['save']) ? $save = 0 : $save = decode_gpc($_POST['save']);

//-----------------------------------------------------------------------------
// Ecriture de la valeur des paramètres modifiés
//-----------------------------------------------------------------------------
$userlist = ReadCSVRows(PATH_DAT."users/list".DBEXT);
if ($save == 1) {
   function verifier_url_site ($url_site) {
      $url_site = trim($url_site);
      if ($url_site == '') {
         if (!empty($_SERVER['HTTP_HOST'])) $url_site = $_SERVER['HTTP_HOST'];
         $url_site .= site_path();
      }
      $url_site = encode_url_components($url_site, 'http', false);
      $url_site = str_replace('http://', '', $url_site);  // Suppression de 'http://' au début
      $url_site = preg_replace('#/$#', '', $url_site);    // Suppression de '/' à la fin
      return $url_site;
   }
   if ($cfg['multiuser']) {
      $userlist = ReadCSVRows(PATH_DAT."users/list".DBEXT);
      function SetUserAdmin ($userold, $usernew, $wri=false) {
         global $userlist;
         $mail = "";
         $usernewlogin=$userlist[$usernew][2];
         $useroldlogin=$userlist[$userold][2];
         $new=ReadCSVPairs(PATH_DAT."users/profile/".$usernewlogin.DBEXT);
         if($new['level'] == 5) {
            $new['level'] = 6;
            $old = ReadCSVPairs(PATH_DAT."users/profile/".$useroldlogin.DBEXT);
            if ($old['level'] == 6) {
               $old['level'] = 5;
               $mail = $new['mail'];
               if ($wri) {
                  WriteCSVPairs(PATH_DAT."users/profile/".$useroldlogin.DBEXT, $old);
                  WriteCSVPairs(PATH_DAT."users/profile/".$usernewlogin.DBEXT, $new);
                  $userlist[$usernew][0] = '6';
                  $userlist[$userold][0] = '5';
                  WriteCSVRows(PATH_DAT."users/list".DBEXT, $userlist);
               }
            }
         }
         return $mail;
      }
   }
   $mess_err = $mess_info = array();
###--- Data import   
   $cfgSiteURL = (empty($_POST['site_url'])) ? "" : decode_gpc($_POST['site_url']);
   $cfgAdmin = (empty($_POST['site_admin'])) ? "" : decode_gpc($_POST['site_admin']);
   $cfgMail = (empty($_POST['site_mail'])) ? "" : decode_gpc($_POST['site_mail']);
   $cfgLangs = (empty($_POST['langs'])) ? array() : decode_gpc($_POST['langs']);
   $cfgTitle = (empty($_POST['title'])) ? array() : decode_gpc($_POST['title']);
   $cfgSlogan = (empty($_POST['slogan'])) ? array() : decode_gpc($_POST['slogan']);
   $cfgDescription = (empty($_POST['description'])) ? array() : decode_gpc($_POST['description']);
   $cfgKeywords = (empty($_POST['keywords'])) ? array() : decode_gpc($_POST['keywords']);
   $cfgCHMOD = (empty($_POST['chmod'])) ? '' : decode_gpc($_POST['chmod']);
   $cfg['debug'] = ($_POST['debug'] == "") ? "" : "on";
   $cfg['editor'] = ($_POST['editor'] == "") ? "whizzywig" : decode_gpc($_POST['editor']);
###--- Data verify     
   if (!file_exists(PATH_DAT.'users/list'.DBEXT)) $cfg['multiuser'] = 0;
   $cfg['site_url'] = verifier_url_site ($cfgSiteURL);   
   if (MailVerify($cfgMail)) $cfg['site_mail'] = $cfgMail;
   if ($cfgAdmin != $cfg['site_admin']) {
      if ($cfg['multiuser']) {
         if (SetUserAdmin($cfg['site_admin'], $cfgAdmin) != "") {
            $cfg['site_mail'] = SetUserAdmin($cfg['site_admin'],$cfgAdmin, true);
            $cfg['site_admin'] = $cfgAdmin;
         }
      } else {
         if (UserNameVerify($cfgAdmin)) {
            $cfg['site_admin'] = $cfgAdmin;
            $user = ReadCSVPairs(PATH_DAT."config/usr_".USER_ID.DBEXT);
            $user['name'] = $cfgAdmin;
            $user['mail'] = $cfgMail;
            if (!isset($user['datein'])) $user['datein'] = GetIsoDateTime();
            WriteCSVPairs(PATH_DAT."config/usr_".USER_ID.DBEXT, $user);
            unset($user);
         }
      }
   }
   if (file_exists(PATH."skin/".$cfgTheme."/config_skin".INCEXT)) $cfg['theme'] = $cfgTheme;
   if (!file_exists("editors/".$cfg['editor']."/func_editor".INCEXT))  $cfg['editor'] = 'whizzywig';
   foreach($cfg as $k => $v) {
      if (strstr($k, 'title_') || strstr($k, 'slogan_') || strstr($k, 'description_')| strstr($k, 'keywords_')) 
          unset ($cfg[$k]);  
   }
   $cfgLangs = array_unique(array_values(array_filter($cfgLangs)));
   $count = count($cfgLangs);
   for($i = 0;$i<$count;$i++) {
      if (!file_exists(PATH.'include/lang/'.$cfgLangs[$i].'/flag.png')) {
         unset($cfgLangs[$i]);
      } else {
         $lg = $cfgLangs[$i];
         $cfg['title_'.$lg] =  $cfgTitle[$i];
         $cfg['slogan_'.$lg] =  $cfgSlogan[$i];
         $cfg['description_'.$lg] = $cfgDescription[$i];
		 $cfg['keywords_'.$lg] =  $cfgKeywords[$i];											 
      }
   }
   $cfg['langs'] = implode("|", $cfgLangs);
   $langs = $cfgLangs;
   $cfg['multilang'] = ($count>1) ? 1 : 0;
   $cfg['CHMOD'] = trim($cfgCHMOD);
   if ($cfg['CHMOD'] > 0 && ($cfg['CHMOD'] < 644 || $cfg['CHMOD'] > 777)) $cfg['CHMOD'] = "664";
   WriteCSVPairs(PATH_DAT."config/config".DBEXT, $cfg);
}

//=============================================================================
//                          Affichage de la page
//=============================================================================


include("include/hpage.inc");
echo '<div class="w23">
<p style="text-align: center"> <strong>'.$msg_pnl['change_settings'].'</strong></p>
<p style="text-align: center"><br />'.$msg_pnl['site_settings'].'<br />
<br />
</p>
<p style="text-align: center"><a href="panel.php">'.$msg_pnl['back_admin'].'</a> ||  <strong><a href="panel.php?logout=1">'.$msg_pnl['logout'].'</a> </strong></p>
';

//-----------------------------------------------------------------------------
// Formulaire général
//-----------------------------------------------------------------------------

echo '
<form class="pnl" action="panel.php?pg=settings" method="post" accept-charset="'.CHARSET.'">
<fieldset>
   <input type="hidden" name="save" value="1" />
   <div>
      <h3>'.$msg_pnl['admin_info'].'</h3>
      <label>'.$msg_pnl['admin_name'].'</label>
';
if ($cfg['multiuser']) {
   if (!isset($userlist)) $userlist = ReadCSVRows(PATH_DAT."users/list".DBEXT);
   echo   '<select name="site_admin">
';
   foreach ($userlist as $useradmin => $set) {
      if ($set[0] > 4) {
         echo '<option value="'.$useradmin.'"';
         if ($useradmin == $cfg['site_admin']) echo ' selected';
         echo '>'.$useradmin."</option>\n";
      }
   }
   echo "</select>\n";
} else {
   echo '<input type="text" name="site_admin" value="'.$cfg['site_admin'].'">
';
}    
echo '<label>'.$msg_pnl['admin_email'].'</label>
      <input type="text" name="site_mail" value="'.$cfg['site_mail'].'">
      <h3>'.$msg_pnl['site_info'].'</h3>
      <label>'.$msg_pnl['url'].'</label>
      <input type="text" name="site_url" value="'.$cfg['site_url'].'">
      <label>'.$msg_pnl['CHMOD'].'</label>
      <input type="text" name="chmod" value="'.$cfg['CHMOD'].'">
';
$checked = ($cfg['debug']) ? 'checked' : '';      
echo '  <label>'.$msg_pnl['debug'].'</label>
      <input type="checkbox" name="debug" '.$checked.'>';
echo "\n</div>\n";
###-- Editor
$workpath = 'editors/';
$tempeditors = GetDirList($workpath);
$editors = array();
foreach ($tempeditors as $editor) 
   if (file_exists($workpath.$editor.'/func_editor'.INCEXT)) $editors[] = $editor;
$count = count($editors);
if ($count > 1) {
   echo '<div>
      <h3>'.$msg_pnl['editor'].'</h3>';   
   //echo '  <label>'.$msg_pnl['debug']."</label>\n";
   DisplaySelect('editor', $editors, $editors, $cfg['editor'], $class="", $selnone=false);
   echo "</div>\n";
}
###-- Languages -------------------
$workpath = PATH_INC.'lang/';
$langlist = GetDirList($workpath);
echo'<h3>'.$msg_pnl['multilingual'].'</h3>
<p>'.$msg_pnl['multilingual_info'].'<br /></p>';
$count = min(6, count($langlist));
if ($count > 0) {
   echo "<div>\n";
   sort($langlist);
   for ($i = 0; $i < $count; $i++) {
      if (file_exists($workpath.$langs[$i]."/flag.png")) {
         $flaglang = '<img src="'.PATH_LNK.'include/lang/'.$langs[$i].'/flag.png" style="width: 24px; height:16px;" alt="'.$langs[0].'" /> ';
      } else $flaglang ="";
      echo '      <label>'.$flaglang.$msg_pnl['language'].' '.($i+1)."</label>\n";
      echo '<p>'.$msg_pnl['language']."\n";
      echo '<select name="langs['.$i.']">'.PHP_EOL;
      if ($i == 1) {
         $langlist[] = "";
         sort($langlist);
      }
      foreach ($langlist as $l) {
         echo '<option value="'.$l.'"';
         if ($l == $langs[$i]) echo ' selected="selected"';
         echo '>'.$l.'</option>'.PHP_EOL;
      }
      echo '</select></p>  
         <label>'.$flaglang.$msg_pnl['site_name'].'</label>
         '.'<input type="text" name="title['.$i.']" value="'.$cfg['title_'.$langs[$i]].'">
         <label>'.$flaglang.$msg_pnl['slogan'].'</label>
         '.'<input type="text" name="slogan['.$i.']" value="'.$cfg['slogan_'.$langs[$i]].'">
         <label>'.$flaglang.$msg_pnl['description'].'</label>
         <input type="text" name="description['.$i.']" value="'.$cfg['description_'.$langs[$i]].'">
         <label>'.$flaglang.$msg_pnl['keywords'].'</label>
         <input type="text" name="keywords['.$i.']" value="'.$cfg['keywords_'.$langs[$i]].'">														  
   ';
   }
   echo "</div>\n";
}  
echo '
<hr />
<p style="text-align: center"><br /><input class="btn" type="submit" value="'.$msg_pnl['config_save'].'" /></p>
</fieldset>
</form>
<p style="text-align: center"><a href="panel.php">'.$msg_pnl['back_admin'].'</a> ||  <strong><a href="panel.php?logout=1">'.$msg_pnl['logout'].'</a> </strong></p>
</div>
';
?>
